	list p=16f84
;**************************************************************
;*
;* Pinbelegung
;*	----------------------------------	
;*	PORTA: 	0 Ziffer	-----------------------------------------------------+
;*		1 Ziffer	-------------------------------------+               I
;*		2 Ziffer	---------------------+               I               I
;*		3 Ziffer	-----+               I               I               I
;*		4 Eingang	     I               I               I               I  
;*	PORTB:	0 Segment B	   AAAAA	   AAAAA	   AAAAA	   AAAAA
;*		1 Segment F	  F     B	  F     B	  F     B	  F     B
;*		2 Segment A	  F     B	  F     B	  F     B	  F     B
;*		3 Segment G	   GGGGG  	   GGGGG  	   GGGGG  	   GGGGG  
;*		4 Segment H	  E     C	  E     C	  E     C	  E     C
;*		5 Segment C	  E     C	  E     C	  E     C	  E     C
;*		6 Segment E	   DDDDD  HH	   DDDDD  HH	   DDDDD  HH	   DDDDD  HH
;*		7 Segment D    
;*
;**************************************************************
;
; sprut (zero) Bredendiek 06/2000
;
; Stopuhr zehntel Sekunden
;  Anzeige M.SS.Z
;
; liegt am Eingang RA4 (Pin3) H-Pegel luft die Uhr
; liegt der Eingang RA4 auf Masse, steht die Uhr
; bei Reset fngt die Uhr bei 0.00.0 an
;
;**************************************************************
; Includedatei fr den 16F84 einbinden

	#include <P16f84.INC>
; Konstanten

	__CONFIG	_PWRTE_ON & _WDT_OFF & _XT_OSC

DP	Equ	4		; Position des Dezimalpunkts in PORTB

; Variablennamen vergeben

w_copy	Equ	0x20		; Backup fr Akkuregister
s_copy	Equ	0x21		; Backup fr Statusregister
Ziffer1	Equ	0x22		; Wert des LSD
Ziffer2	Equ	0x23		; Wert der zweitkleinsten Stelle
Ziffer3	Equ	0x24		; Wert der zweitgrten Stelle
Ziffer4	Equ	0x25		; Wert des MSD
Digit	Equ	0x26		; Ziffernzhler
ar	Equ	0x27
Timer2	Equ	0x28		; Vorteiler von 50 Hz auf 10 Hz

;**************************************************************
; los gehts mit dem Programm

	org 	0
	goto	Init	

;**************************************************************
; die Interuptserviceroutine

	org 	4 	
intvec	bcf	INTCON, GIE	; disable Interupt 

	movwf	w_copy		; w retten
	swapf	STATUS, w 	; STATUS retten
	movwf	s_copy		;

	movlw	D'131'		; 256-125=131 ((1MHz : 32 ): 125 = 250 Hz)
	movwf	TMR0

; Intrupt servic routine
Int_serv 

	bsf	PORTA, 0	; Ziffer1 aus
	bsf	PORTA, 1	; Ziffer2 aus
	bsf	PORTA, 2	; Ziffer3 aus
	bsf	PORTA, 3	; Ziffer4 aus

	decf	Digit,f		; Ziffernzhler verringern
;Digit=4: anzeigen Ziffer 4
;Digit=3: anzeigen Ziffer 3
;Digit=2: anzeigen Ziffer 2
;Digit=1: anzeigen Ziffer 1
;Digit=0: andere Aktionen, keine Anzeige

	btfsc	STATUS, Z
	goto	Int_0		; Z-Flag=1 ergo Digit=0
	movfw	Digit
	movwf	ar
	decf	ar, f
	btfsc	STATUS, Z
	goto	Int_1		; Digit=1
	decf	ar, f
	btfsc	STATUS, Z
	goto	Int_2		; Digit=2
	decf	ar, f
	btfsc	STATUS, Z
	goto	Int_3		; Digit=3
	goto	Int_4		; Digit=4

Int_0
	movlw	5
	movwf	Digit

	btfss	PORTA, 4
	goto	Int_end		; Stop-Taste gedrckt

	decf	Timer2, f	; von 5 bis 0 zhlen (50 Hz / 5 = 10 Hz)
	btfss	STATUS, Z	
	goto	Int_end		; Timer2 <> 0

	movlw	5
	movwf	Timer2
	incf	Ziffer1, f	; 1/10 Sekunden erhhen
	movlw	D'10'
	subwf	Ziffer1, w
	btfss	STATUS, Z	
	goto	Int_end		; 1/10 Sekunden <> 10	

	clrf	Ziffer1
	incf	Ziffer2, f	; 1/10 Sekunden erhhen
	movlw	D'10'
	subwf	Ziffer2, w
	btfss	STATUS, Z	
	goto	Int_end		; 1 Sekunden <> 10	

	clrf	Ziffer2
	incf	Ziffer3, f	; 10 Sekunden erhhen
	movlw	D'6'
	subwf	Ziffer3, w
	btfss	STATUS, Z	
	goto	Int_end		; 10 Sekunden <> 6

	clrf	Ziffer3
	incf	Ziffer4, f	; 1 Minuten erhhen
	movlw	D'10'
	subwf	Ziffer4, w
	btfss	STATUS, Z	
	goto	Int_end		; 1 Minuten <> 10

	clrf	Ziffer4
	goto	Int_end

Int_1
	movfw	Ziffer1		; Wert der 1. Ziffer
	call	Segmente
	movwf	PORTB		; Segmente einschalten
	bcf	PORTA, 0	; 1. Ziffer einschalten
	goto	Int_end

Int_2
	movfw	Ziffer2		; Wert der 2. Ziffer
	call	Segmente
	movwf	PORTB		; Segmente einschalten
	bcf	PORTB, DP	; Dezimalpunkt ein
	bcf	PORTA, 1	; 2. Ziffer einschalten
	goto	Int_end

Int_3
	movfw	Ziffer3		; Wert der 3. Ziffer
	call	Segmente
	movwf	PORTB		; Segmente einschalten
	bcf	PORTA, 2	; 3. Ziffer einschalten
	goto	Int_end

Int_4
	movfw	Ziffer4		; Wert der 4. Ziffer
	call	Segmente
	movwf	PORTB		; Segmente einschalten
	bcf	PORTB, DP	; Dezimalpunkt ein
	bcf	PORTA, 3	; 4. Ziffer einschalten
	goto	Int_end


Int_end	swapf	s_copy, w	; STATUS zurck
	movwf	STATUS 
	swapf	w_copy, f	; w zurck mit flags
	swapf	w_copy, w

	bcf	INTCON, T0IF	; Interupt-Flag lschen
	bsf	INTCON, GIE	; enable Interupt

	retfie

; 7-Segment-Tabelle
Segmente
	addwf	PCL, f
	retlw	B'00011000'	; 0
	retlw	B'11011110'	; 1
	retlw	B'00110010'	; 2
	retlw	B'01010010'	; 3
	retlw	B'11010100'	; 4
	retlw	B'01010001'	; 5
	retlw	B'00010001'	; 6
	retlw	B'11011010'	; 7
	retlw	B'00010000'	; 8
	retlw	B'01010000'	; 9

;**************************************************************

; Port A/B auf Ausgabe stellen

Init
	movlw	B'11111111'
	movwf	PORTA
	movwf	PORTB		; Anzeige dunkel
	bsf     STATUS, RP0	; auf Bank 1 umschalten
	movlw	B'11110000'	; PortA RA0-RA3 output
	movwf	TRISA
	movlw	B'00000000'	; PortB alle output
	movwf	TRISB
	bcf     STATUS, RP0	; auf Bank 0 zurckschalten


; Zeit 0 einstellen

	clrf	Ziffer1
	clrf	Ziffer2
	clrf	Ziffer3
	clrf	Ziffer4

	movlw	5
	movwf	Digit		; Ziffernzhler einstellen

; 250 Hz-Timer-Interupt einstellen
	bsf     STATUS, RP0	; auf Bank 1 umschalten
	movlw	B'10000100'	; internen Takt zhlen, Vorteiler zum Timer0, 32:1
	movwf	OPTION_REG
	movlw	D'131'		; 256-125=131 ((1MHz : 32 ): 125 = 250 Hz)
	bcf     STATUS, RP0	; auf Bank 0 zurckschalten
	movwf	TMR0

	movlw	5
	movwf	Timer2		; 50Hz -> 10 Hz Teiler

	bsf	INTCON, T0IE	; Timer0 interupt erlauben
	bsf	INTCON, GIE	; Interupt erlauben


loop	goto	loop		; eine Endlosschleife

;**********************************************************


	end



